## hydrogen 1.2.6+dfsg

=== Makefile ===
###
### must have the following commandline tools:
###
### itstool  (Debian package: itstool)
### msgfmt   (Debian package: gettext)
### msgmerge (Debian package: gettext)	
### xmlto    (Debian package: xmlto)
### xmllint  (Debian package: libxml2-utils)
###

MANUAL_MASTER = manual.docbook
TUTORIAL_MASTER = tutorial.docbook

XMLTO_OPTS = --stringparam section.autolabel=1 \
	--stringparam use.is.as.filename=1 \
	--stringparam toc.max.depth=3 \
	--stringparam xref.with.number.and.title=0 \
	--stringparam section.label.includes.component.label=1 \
	--stringparam admon.graphics.extension=.svg \
	--stringparam admon.graphics=1 \
	--stringparam admon.style="'margin-left: 5%;'" \
	--stringparam ulink.target="_blank"

ITSTOOL = itstool
MSGMERGE = msgmerge
MSGFMT = msgfmt
XMLTO = xmlto
XMLLINT = xmllint

all: manual.pot manual_en.html tutorial.pot tutorial_en.html tutorial_fr.html tutorial_it.html clean

clean:
	-rm -f *.mo *_validated *.dbk *.bak

# Derive language from filename (and extension)
define LANGUAGE =
$$(echo -n $(1) | sed 's/.*_\(..\)\.$(2)/\1/')
endef

%.html: %.dbk %.dbk_validated
	sed -i "s%generated_en/%generated_$(call LANGUAGE,$<,dbk)/%g" $<
	LL=$(call LANGUAGE,$<,dbk) ; \
	$(XMLTO) html-nochunks $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		--stringparam html.stylesheet='res/docbook.css' \
		--stringparam html.script='res/docbook.js' \
		--stringparam img.src.path=img/ \
		--stringparam admon.graphics.path=img/admonitions/ \
		-x res/xslt/html/docbook.xsl \
		$<
	LL=$(call LANGUAGE,$<,dbk) ; \
	$(XMLTO) html -o $*_chunked $(XMLTO_OPTS) \
		--stringparam l10n.gentext.language=$$LL \
		--stringparam html.stylesheet='../res/docbook.css' \
		--stringparam html.script='../res/docbook.js' \
		--stringparam img.src.path=../img/ \
		--stringparam admon.graphics.path=../img/admonitions/ \
		-x res/xslt/html/chunk.xsl \
		$<

%.dbk_validated: %.dbk
	$(XMLLINT) --noout --valid $^
	touch $@

## Special rule for master manual and tutorial
%_en.dbk: %.docbook
	cp -f $^ $@

manual_%.dbk: manual_%.mo manual_%.po $(MANUAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(MANUAL_MASTER)

manual.pot: $(MANUAL_MASTER)
	$(ITSTOOL) -o manual.pot $<

manual_%.po: manual.pot
	$(MSGMERGE) -U $@ manual.pot --backup=simple --no-wrap --verbose

manual_%.mo: manual_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

tutorial_%.dbk: tutorial_%.mo tutorial_%.po $(TUTORIAL_MASTER)
	$(ITSTOOL) -m $< -o $@ --lang $* $(TUTORIAL_MASTER)

tutorial.pot: $(TUTORIAL_MASTER)
	$(ITSTOOL) -o tutorial.pot $<

tutorial_%.po: tutorial.pot
	$(MSGMERGE) -U $@ tutorial.pot --backup=simple --no-wrap --verbose

tutorial_%.mo: tutorial_%.po
	`cat $< | sed 's/, fuzzy//g' > $<.bak`
	$(MSGFMT) --check -o $@ $<.bak

=== cmake/rtclock/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project($CMAKE_PROJECT_NAME)
add_definitions()
include_directories()
link_directories()
add_executable(rtclock rtclock.c)
target_link_libraries(rtclock "rt" )

=== cmake/sscanf/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project($CMAKE_PROJECT_NAME)
add_definitions()
include_directories()
link_directories()
add_executable(sscanf sscanf.c)
target_link_libraries(sscanf  )

=== data/i18n/CMakeLists.txt ===
# make clean does not delete *.ts and *.qm files
SET_DIRECTORY_PROPERTIES(PROPERTIES CLEAN_NO_CUSTOM 1)

FILE(GLOB TS_FILES ${CMAKE_CURRENT_LIST_DIR}/*.ts)

if(H2CORE_HAVE_QT6)
	QT6_ADD_TRANSLATION(QM_FILES ${TS_FILES})
else()
	QT5_ADD_TRANSLATION(QM_FILES ${TS_FILES})
endif()
ADD_CUSTOM_TARGET(translations ALL DEPENDS ${QM_FILES})

IF(MINGW)
	INSTALL(FILES ${QM_FILES} DESTINATION "./data/i18n")
ELSE()
	INSTALL(FILES ${QM_FILES} DESTINATION "${H2_SYS_PATH}/data/i18n")
ENDIF()

=== src/core/CMakeLists.txt ===

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/config.h.in" "${CMAKE_CURRENT_BINARY_DIR}/config.h" @ONLY)

file(GLOB_RECURSE hydrogen_INCLUDES *.h)
file(GLOB_RECURSE hydrogen_SOURCES *.cpp *.cc *.c)
list(APPEND hydrogen_INCLUDES ${CMAKE_CURRENT_BINARY_DIR}/config.h)

add_library( hydrogen-core-${VERSION} ${H2CORE_LIBRARY_TYPE} ${hydrogen_SOURCES})
include_directories( include
    ${CMAKE_SOURCE_DIR}/src                     # regular headers
    ${CMAKE_SOURCE_DIR}/include                 # regular headers
    ${CMAKE_CURRENT_BINARY_DIR}/../             # generated config.h
    ${QT_INCLUDES}
    ${LIBTAR_INCLUDE_DIRS}
    ${LIBARCHIVE_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${PULSEAUDIO_INCLUDE_DIRS}
    ${ALSA_INCLUDE_DIRS}
    ${OSS_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
    ${PORTAUDIO_INCLUDE_DIRS}
    ${PORTMIDI_INCLUDE_DIRS}
    ${COREAUDIO_INCLUDE_DIRS}
    ${COREMIDI_INCLUDE_DIRS}
    ${LASH_INCLUDE_DIRS}
    ${LRDF_INCLUDE_DIRS}
    ${OSC_INCLUDE_DIRS}
    ${RUBBERBAND_INCLUDE_DIRS}
)

target_link_libraries(hydrogen-core-${VERSION}
    ${LIBTAR_LIBRARIES}
    ${LIBARCHIVE_LIBRARIES}
    ${LIBSNDFILE_LIBRARIES}
    ${ALSA_LIBRARIES}
    ${OSS_LIBRARIES}
    ${JACK_LIBRARIES}
    ${PORTAUDIO_LIBRARIES}
    ${PORTMIDI_LIBRARIES}
    ${AUDIOUNIT_LIBRARY}
    ${CORESERVICES_LIBRARY}
    ${COREAUDIO_LIBRARIES}
    ${COREMIDI_LIBRARIES}
    ${PULSEAUDIO_LIBRARIES}
    ${LASH_LIBRARIES}
    ${LRDF_LIBRARIES}
    ${RUBBERBAND_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    ${OSC_LIBRARIES}
)

target_link_libraries(hydrogen-core-${VERSION}
	Qt${QT_VERSION_MAJOR}::Core
	Qt${QT_VERSION_MAJOR}::Xml
    Qt${QT_VERSION_MAJOR}::Test
	Qt${QT_VERSION_MAJOR}::Gui # For QColor
)

#SET_TARGET_PROPERTIES(hydrogen-core-${VERSION} PROPERTIES PUBLIC_HEADER   "${hydrogen_INCLUDES}" )
set_property(TARGET hydrogen-core-${VERSION} PROPERTY CXX_STANDARD 17)


if(WIN32)
    # On Windows we do not want to install import library (.dll.a)
    install(TARGETS hydrogen-core-${VERSION}
        LIBRARY DESTINATION "${H2_LIB_PATH}"
        RUNTIME DESTINATION "${H2_LIB_PATH}"
    )
else()
    install(TARGETS hydrogen-core-${VERSION}
        LIBRARY DESTINATION "${H2_LIB_PATH}"
        RUNTIME DESTINATION "${H2_LIB_PATH}"
        ARCHIVE DESTINATION "${H2_LIB_PATH}"
    )
endif()

if(NOT APPLE AND NOT WIN32)
    install(DIRECTORY ${CMAKE_SOURCE_DIR}/src/core DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hydrogen" FILES_MATCHING PATTERN "*.h" PATTERN ".svn" EXCLUDE)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/config.h" DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/hydrogen" )
endif()

=== src/player/CMakeLists.txt ===

file(GLOB_RECURSE h2player_SRCS *.cpp)

include_directories(
    ${CMAKE_SOURCE_DIR}/src                     # top level headers
    ${CMAKE_BINARY_DIR}/src                     # generated config.h
    ${QT_INCLUDES}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
)

add_executable(h2player WIN32 MACOSX_BUNDLE ${h2player_SRCS} )

set_property(TARGET h2player PROPERTY CXX_STANDARD 17)
target_link_libraries(h2player
	hydrogen-core-${VERSION}
	Qt${QT_VERSION_MAJOR}::Widgets
	)

add_dependencies(h2player hydrogen-core-${VERSION})

install(TARGETS h2player RUNTIME DESTINATION ${H2_BIN_PATH} BUNDLE DESTINATION ${H2_BIN_PATH})

=== tests/jackTimebase/h2JackTimebase/CMakeLists.txt ===

file(GLOB_RECURSE h2JackTimebase_SRCS *.cpp)

include_directories(
    ${CMAKE_SOURCE_DIR}/src                     # top level headers
    ${CMAKE_SOURCE_DIR}/tests/jackTimebase/     # dedicated test sources
    ${CMAKE_BINARY_DIR}/src                     # generated config.h
    ${QT_INCLUDES}
    ${OSC_INCLUDE_DIRS}
    ${LIBSNDFILE_INCLUDE_DIRS}
    ${CPPUNIT_INCLUDE_DIRS}
    ${JACK_INCLUDE_DIRS}
)

add_executable(h2JackTimebase WIN32 MACOSX_BUNDLE ${h2JackTimebase_SRCS} )

set_property(TARGET h2JackTimebase PROPERTY CXX_STANDARD 17)
target_link_libraries(h2JackTimebase
	hydrogen-core-${VERSION}
	Qt${QT_VERSION_MAJOR}::Widgets
	${CPPUNIT_LIBRARIES}
	${OSC_LIBRARIES}
	)

add_dependencies(h2JackTimebase hydrogen-core-${VERSION})

install(TARGETS h2JackTimebase RUNTIME DESTINATION ${H2_BIN_PATH} BUNDLE DESTINATION ${H2_BIN_PATH})

=== debian/changelog ===
hydrogen (1.2.6+dfsg-1) unstable; urgency=medium

  [ Dennis Braun ]
  * New upstream version 1.2.6+dfsg (Closes: #1094294)
  * Drop the doc package for now, because it is depecrecated
    See https://github.com/hydrogen-music/documentation/blob/main/README.md
    Upstream documentation will be used instead
  * Provide manpages for h2cli and h2player and update the hydrogen manpage
  * d/copyright: Update GPL-2+ and GPL-3+ license text
  * Fix wrong date format in manual page
  * Bump Standards-Version to 4.7.2, no changes
  * Remove redundant rules-requires-root field
  * Refresh patchset with gbp pq rebase
  * Change my email address

  [ Nicholas D Steeves ]
  * Acknowledge friendly NMU.
  * Drop 0001-CMake-bump-minimum-required-version-to-3.5.patch, which is
    already part of this upstream release.
  * Drop myself from Uploaders.

 -- Dennis Braun <snd@debian.org>  Tue, 25 Nov 2025 17:37:03 +0100

hydrogen (1.2.2+dfsg-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Backport upstream fix for FTBFS with CMake 4. (Closes: #1112997)

 -- Adrian Bunk <bunk@debian.org>  Fri, 21 Nov 2025 14:25:55 +0200

hydrogen (1.2.2+dfsg-2) unstable; urgency=medium

  * Remove redundant and incomplete copy of "old_tutorial" because upstream
    now ships the canonical tutorial in its entirety in
    /usr/share/hydrogen/data/doc/tutorial_??.html.
  * Decruft docbase registration of "old_tutorial" and add the new
    upstream-defined tutorial location (this should have been done for
    1.2.2+dfsg-1).
  * Clean up spare /usr/share/hydrogen/data/doc/res/LICENSE.
  * Migrate from pkg-config to pkgconf.
  * Lintian no longer recognises the validity of CC0-1.0 relicenced to GPL-2+,
    so declare that the appdata.xml is CC0-1.0 (lintian is wrong, and this is
    only to silence lintian).
  * Upload to unstable.

 -- Nicholas D Steeves <sten@debian.org>  Sat, 03 Aug 2024 23:13:19 -0400

=== debian/control ===
Source: hydrogen
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Dennis Braun <snd@debian.org>
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 qtbase5-dev,
 libqt5xmlpatterns5-dev,
 qttools5-dev,
 libcppunit-dev,
 libz-dev,
 pkgconf,
 libarchive-dev,
 poxml,
 libasound2-dev [linux-any],
 libjack-dev,
 liblrdf-dev,
 libsndfile1-dev,
 portaudio19-dev,
 libportmidi-dev [linux-any],
 libpulse-dev,
 liblo-dev,
 libqt5svg5-dev,
 qttools5-dev-tools,
Standards-Version: 4.7.2
Homepage: http://www.hydrogen-music.org/
# Unfortunately, as of 2020-11-26, https://www.hydrogen-music.org/ has the
# following SSL cert issue: NET::ERR_CERT_COMMON_NAME_INVALID
# This is remains unfixed as of 2022-09-28, and was reported here:
# https://github.com/hydrogen-music/hydrogen/issues/1658
Vcs-Git: https://salsa.debian.org/multimedia-team/hydrogen.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/hydrogen

Package: hydrogen
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 hydrogen-data (= ${source:Version})
Recommends:
 hydrogen-drumkits,
 rubberband-cli
Suggests:
 ladspa-plugin
Breaks: hydrogen-data (<< 1.0.1-2)
Replaces: hydrogen-data (<< 1.0.1-2)
Description: advanced drum machine/step sequencer
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 General features:
  * Very user-friendly, modular, fast and intuitive graphical interface
    based on Qt 5.
  * Sample-based stereo audio engine, with import of sound samples in
    .wav, .au and .aiff formats.
  * Support of samples in compressed FLAC file.
 .
 Sequencer and mixer features:
  * Pattern-based sequencer, with unlimited number of patterns and
    ability to chain patterns into a song.
  * Up to 64 ticks per pattern with individual level per event and
    variable pattern length.
  * 32 instrument tracks with volume, mute, solo, pan capabilities.
  * Multi layer support for instruments (up to 16 samples for each
    instrument).
  * Ability to import/export song files.
  * Unique human velocity, human time, pitch and swing functions.
  * Multiple patterns playing at once.
 .
 Other features:
  * JACK, ALSA, PortAudio, OSS and PulseAudio audio drivers.
  * ALSA MIDI and PortMidi input with assignable midi-in channel (1..16,
    ALL).
  * Import/export of drumkits.
  * Export song to wav file.
  * Export song to midi file.

Package: hydrogen-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: hydrogen
Breaks: hydrogen (<< 0.9.7-5~)
Replaces: hydrogen (<< 0.9.7-5~)
Description: advanced drum machine/step sequencer (data)
 Hydrogen is an advanced drum machine which provides a professional,
 yet simple and intuitive, pattern-based drum programming interface.
 .
 This package contains the architecture-independent data files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CMAKE_EXTRA_FLAGS = -DWANT_SHARED=OFF \
 -DWANT_PORTAUDIO=ON \
 -DWANT_PORTMIDI=ON \
 -DWANT_RUBBERBAND=ON

export QTDIR=/usr/lib/qt5

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake -- $(DEB_CMAKE_EXTRA_FLAGS)

execute_after_dh_auto_build:
	mv ./data/img/h2-icon.bmp ./data/img/h2-icon.png

execute_before_dh_clean:
	mv ./data/img/h2-icon.png ./data/img/h2-icon.bmp || true

=== debian/watch ===
version=4
opts=\
dversionmangle=s/\+(debian|dfsg|ds|deb)(\.?\d+)?$//,\
uversionmangle=s/(\d)-(alpha|beta|rc)/$1~$2/,\
oversionmangle=s/$/\+dfsg/ \
  https://github.com/hydrogen-music/hydrogen/tags .*/v?(\d\S+)\.tar\.gz
